## unison2.32.52 2.32.52

=== Makefile ===
#######################################################################
# $I1: Unison file synchronizer: src/Makefile $
# $I2: Last modified by bcpierce on Sun, 22 Aug 2004 22:29:04 -0400 $
# $I3: Copyright 1999-2004 (see COPYING for details) $
#######################################################################
## User Settings

# Set NATIVE=false if you are not using the native code compiler (ocamlopt)
# This is not advised, though: Unison runs much slower when byte-compiled.
#
# If you set NATIVE=false, then make sure that the THREADS option below is
# also set to false unless your OCaml installation has true posix-compliant
# threads (i.e., -with-pthreads was given as an option to the config script).
NATIVE=true

# Use THREADS=false if your OCaml installation is not configured with the
# -with-pthreads option.  (Unison will crash when compiled with THREADS=true
# if the -with-pthreads configuration option was not used.)
THREADS=false

# User interface style.  For legal values, see Makefile.OCaml.
# You probably don't need to set this yourself -- it will be set to
# an appropriate value automatically, depending on whether the lablgtk
# library is available.
#
# UISTYLE=text

########################################################################
########################################################################
#     (There should be no need to change anything from here on)       ##
########################################################################

######################################################################
# Building installation instructions

all:: strings.ml buildexecutable

all:: INSTALL

INSTALL: $(NAME)$(EXEC_EXT)
# file isn't made for OS X, so check that it's there first
	(if [ -f $(NAME) ]; then ./$(NAME) -doc install > INSTALLATION; fi)

########################################################################
## Miscellaneous developer-only switches
DEBUGGING=true
PROFILING=false
STATIC=false

# NAME, VERSION, and MAJORVERSION, automatically generated
-include Makefile.ProjectInfo

Makefile.ProjectInfo: mkProjectInfo
	./mkProjectInfo > $@

mkProjectInfo: mkProjectInfo.ml
	ocamlc -o $@ $^

clean::
	$(RM) mkProjectInfo
	$(RM) Makefile.ProjectInfo

########################################################################
### Compilation rules

include Makefile.OCaml

######################################################################
# Installation

INSTALLDIR = $(HOME)/bin/

# This has two names because on OSX the file INSTALL shadows the target 'install'!
install: doinstall

installtext: 
	$(MAKE) -C .. installtext

text: 
	$(MAKE) -C .. text

doinstall: $(NAME)$(EXEC_EXT)
	-mv $(INSTALLDIR)/$(NAME)$(EXEC_EXT) /tmp/$(NAME)-$(shell echo $$$$)
	cp $(NAME)$(EXEC_EXT) $(INSTALLDIR)
	cp $(NAME)$(EXEC_EXT) $(INSTALLDIR)$(NAME)-$(MAJORVERSION)$(EXEC_EXT)


######################################################################
# Demo

setupdemo-old: all
	-mkdir alice.tmp bob.tmp
	-touch alice.tmp/letter alice.tmp/curriculum
	-mkdir bob.tmp/curriculum
	-touch bob.tmp/curriculum/french
	-touch bob.tmp/curriculum/german
	-mkdir bob.tmp/good_friends
	-mkdir bob.tmp/good_friends/addresses
	-mkdir alice.tmp/good_friends
	-touch alice.tmp/good_friends/addresses
	-touch bob.tmp/good_friends/addresses/alice
	-mkdir alice.tmp/book
	-mkdir bob.tmp/book
	echo "first name:alice \n 2234 Chesnut Street \n Philadelphia" \
	   > bob.tmp/good_friends/addresses/alice
	echo "ADDRESS 1 : BOB \n firstName : bob \n 2233 Walnut Street" \
	   > alice.tmp/good_friends/addresses
	echo "Born in Paris in 1976 ..." > alice.tmp/curriculum
	echo "Ne a Paris en 1976 ..." > bob.tmp/curriculum/french
	echo "Geboren in Paris im jahre 1976 ..." > bob.tmp/curriculum/german
	echo "Dear friend, I received your letter ..."    > alice.tmp/letter
	echo "And then the big bad wolf" > bob.tmp/book/page3
	echo "Title : three little pigs" > alice.tmp/book/page1
	echo "there was upon a time ..." > alice.tmp/book/page2

setupdemo:
	rm -rf a.tmp b.tmp
	mkdir a.tmp
	touch a.tmp/a a.tmp/b a.tmp/c
	mkdir a.tmp/d
	touch a.tmp/d/f
	touch a.tmp/d/g
	cp -r a.tmp b.tmp

modifydemo:
	-rm a.tmp/a
	echo "Hello" > a.tmp/b
	echo "Hello" > b.tmp/b
	date > b.tmp/c
	echo "Hi there" > a.tmp/d/h
	echo "Hello there" > b.tmp/d/h

demo: all setupdemo
	@$(MAKE) run
	@$(MAKE) modifydemo
	@$(MAKE) run

run: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) default a.tmp b.tmp

runbatch: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) default a.tmp b.tmp -batch

runt: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) default a.tmp b.tmp -timers

rundebug: all
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) a.tmp b.tmp -debug all  -ui text

runp: all
	-echo cat > a.tmp/cat
	-echo cat > b.tmp/cat
	-chmod 765 a.tmp/cat
	-chmod 700 b.tmp/cat
	./$(NAME) a.tmp b.tmp

runtext: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/x
	-date > b.tmp/y
	./$(NAME) -ui text a.tmp b.tmp

runsort: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/b
	-date > b.tmp/m
	-date > b.tmp/z
	-date > b.tmp/f
	-date >> b.tmp/f
	-date > b.tmp/c.$(shell echo $$$$)
	-date > b.tmp/y.$(shell echo $$$$)
	./$(NAME) default a.tmp b.tmp -debug sort

runprefer: all
	-mkdir a.tmp b.tmp
	-date > a.tmp/b
	-date > b.tmp/m
	-date > b.tmp/z
	-echo Hello > a.tmp/z
	-date > b.tmp/f
	-date >> b.tmp/f
	-date > b.tmp/c.$(shell echo $$$$)
	-date > b.tmp/y.$(shell echo $$$$)
	./$(NAME) default a.tmp b.tmp -force b.tmp

prefsdocs: all
	./$(NAME) -prefsdocs 2> prefsdocsjunk.tmp
	mv -f prefsdocsjunk.tmp prefsdocs.tmp

# For developers 
runtest:
	$(MAKE) all NATIVE=false DEBUG=true
	./unison test

repeattest:
	$(MAKE) all NATIVE=false DEBUG=true UISTYLE=text
	./unison noprofile a.tmp b.tmp -repeat foo.tmp -debug ui

selftest:
	$(MAKE) all NATIVE=false DEBUG=true UISTYLE=text
	./unison -selftest -ui text -batch 

selftestdebug:
	$(MAKE) all NATIVE=false DEBUG=true UISTYLE=text
	./unison -selftest -ui text -batch -debug all

selftestremote:
	$(MAKE) all NATIVE=false DEBUG=true UISTYLE=text
	./unison -selftest -ui text -batch test.tmp ssh://eniac.seas.upenn.edu/test.tmp 

testmerge:
	$(MAKE) all NATIVE=false UISTYLE=text
	-rm -rf a.tmp b.tmp
	-rm -rf $(HOME)/.unison/backup/file.txt*
	mkdir a.tmp b.tmp
	@echo
	@echo -----------------------------------------------------------
	@echo
	./unison testmerge -ui text -batch
	echo 1OO >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3oo >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 7oo >> a.tmp/file.txt
	echo 8oo >> a.tmp/file.txt
	echo 9oo >> a.tmp/file.txt
	echo 0oo >> a.tmp/file.txt
	echo 1oo >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3oo >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 7oo >> a.tmp/file.txt
	echo 8oo >> a.tmp/file.txt
	echo 9oo >> a.tmp/file.txt
	echo 0oo >> a.tmp/file.txt
	echo 1oo >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3OO >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	./unison testmerge -ui text -batch
	rm a.tmp/file.txt b.tmp/file.txt
	echo 1OO >> a.tmp/file.txt
	echo second >> a.tmp/file.txt
	echo 3oo >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 7oo >> a.tmp/file.txt
	echo 8oo >> a.tmp/file.txt
	echo 9oo >> a.tmp/file.txt
	echo 0oo >> a.tmp/file.txt
	echo 1oo >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3oo >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 5oo >> a.tmp/file.txt
	echo 6oo >> a.tmp/file.txt
	echo 7oo >> a.tmp/file.txt
	echo 8oo >> a.tmp/file.txt
	echo 9oo >> a.tmp/file.txt
	echo 0oo >> a.tmp/file.txt
	echo 1oo >> a.tmp/file.txt
	echo 2oo >> a.tmp/file.txt
	echo 3OO >> a.tmp/file.txt
	echo 4oo >> a.tmp/file.txt
	echo ---
	echo 1OO >> b.tmp/file.txt
	echo 2oo >> b.tmp/file.txt
	echo 3oo >> b.tmp/file.txt
	echo 4oo >> b.tmp/file.txt
	echo 5oo >> b.tmp/file.txt
	echo 6oo >> b.tmp/file.txt
	echo 7oo >> b.tmp/file.txt
	echo 8oo >> b.tmp/file.txt
	echo 9oo >> b.tmp/file.txt
	echo 0oo >> b.tmp/file.txt
	echo 1oo >> b.tmp/file.txt
	echo 2oo >> b.tmp/file.txt
	echo 3oo >> b.tmp/file.txt
	echo 4oo >> b.tmp/file.txt
	echo 5oo >> b.tmp/file.txt
	echo 6oo >> b.tmp/file.txt
	echo 5oo >> b.tmp/file.txt
	echo 6oo >> b.tmp/file.txt
	echo 7oo >> b.tmp/file.txt
	echo 8oo >> b.tmp/file.txt
	echo 9oo >> b.tmp/file.txt
	echo 0oo >> b.tmp/file.txt
	echo 1oo >> b.tmp/file.txt
	echo 2oo >> b.tmp/file.txt
	echo 3OO >> b.tmp/file.txt
	echo end >> b.tmp/file.txt
	@echo
	@echo -----------------------------------------------------------
	@echo
	./unison testmerge -ui text -batch -debug files -debug update -debug backup
	@echo
	@echo -----------------------------------------------------------
	@echo
	./unison testmerge -ui text -batch
	@echo
	@echo -----------------------------------------------------------
	@echo
	cat a.tmp/file.txt
	cat b.tmp/file.txt
	cat $(HOME)/.unison/backup/file.txt


######################################################################
# Tags

# In Windows, tags and TAGS are the same, so make tags stops working
# after the first invocation.  The .PHONY declaration makes it work
# again.
.PHONY: tags

tags:
	-$(ETAGS) *.mli */*.mli *.ml */*.ml */*.m *.c */*.c *.txt

all:: TAGS

TAGS:
	$(MAKE) tags

######################################################################
# Misc

clean::
	-$(RM) *.log *.aux *.log *.dvi *.out *.bak
	-$(RM) -r obsolete
	-$(RM) $(NAME) $(NAME).exe
	-$(RM) $(NAME)-blob.o

clean::
	$(MAKE) -C ubase clean
	$(MAKE) -C lwt clean

ifeq (${OSARCH},osx)
clean::
	-(cd $(UIMACDIR); xcodebuild clean)
	-(cd $(UIMACDIR); $(RM) -r build ExternalSettings.xcconfig)
endif

checkin:
	$(MAKE) -C .. checkin

installremote: 
	$(MAKE) UISTYLE=text
	-unison eniac -path current/unison/trunk/src -batch
	ssh eniac.seas.upenn.edu make -C current/unison/trunk/src installtext

####################################################################
# Documentation strings

# Cons up a fake strings.ml if necessary (the real one is generated when
# we build the documentation, but we need to be able to compile the
# executable here to do that!)
strings.ml:
	echo "(* Dummy strings.ml *)" > strings.ml
	echo "let docs = []" >> strings.ml

=== lwt/Makefile ===

NAME = lwt

OCAMLC = ocamlfind ocamlc -g
OCAMLOPT = ocamlfind ocamlopt
OCAMLDEP = ocamldep

OBJECTS  = pqueue.cmo lwt.cmo lwt_util.cmo lwt_unix.cmo
XOBJECTS = $(OBJECTS:cmo=cmx)

ARCHIVE  = $(NAME).cma
XARCHIVE = $(NAME).cmxa

REQUIRES =
PREDICATES =

all: $(ARCHIVE) 
opt: $(XARCHIVE)

$(ARCHIVE): $(OBJECTS)
	$(OCAMLC) -a -o $(ARCHIVE) -package "$(REQUIRES)" -linkpkg \
	          -predicates "$(PREDICATES)" $(OBJECTS)
$(XARCHIVE): $(XOBJECTS)
	$(OCAMLOPT) -a -o $(XARCHIVE) -package "$(REQUIRES)" -linkpkg \
	          -predicates "$(PREDICATES)" $(XOBJECTS)

.SUFFIXES: .cmo .cmi .cmx .ml .mli

.ml.cmo:
	$(OCAMLC) -package "$(REQUIRES)" -predicates "$(PREDICATES)" \
	          -c $<
.mli.cmi:
	$(OCAMLC) -package "$(REQUIRES)" -predicates "$(PREDICATES)" \
	          -c $<
.ml.cmx:
	$(OCAMLOPT) -package "$(REQUIRES)" -predicates "$(PREDICATES)" \
	          -c $<

depend: *.ml *.mli
	$(OCAMLDEP) *.ml *.mli > depend
include depend

install: all
	{ test ! -f $(XARCHIVE) || extra="$(XARCHIVE) "`basename $(XARCHIVE) .cmxa`.a; }; \
	ocamlfind install $(NAME) *.mli *.cmi $(ARCHIVE) META $$extra

uninstall:
	ocamlfind remove $(NAME)

clean::
	rm -f *.cmi *.cmo *.cmx *.cma *.cmxa *.a *.o *~ *.bak

clean::
	cd example && $(MAKE) clean

=== lwt/example/Makefile ===
all: relay start_editor

OCAMLC = ocamlfind ocamlc

relay: relay.ml
	$(OCAMLC) -o relay -linkpkg -package lwt relay.ml -cclib -s

start_editor : editor.ml
	$(OCAMLC) -o start_editor -linkpkg -package lwt editor.ml -cclib -s

clean:
	rm -f *.cmi *.cmo *~ relay start_editor

=== debian/changelog ===
unison2.32.52 (2.32.52-7ubuntu1) saucy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/change-logfile-location.patch: Change default logfile
      directory to .unison by prepending .unison to name of logfile in
      ubase/trace.ml.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 11 May 2013 14:58:43 -0400

unison2.32.52 (2.32.52-7) unstable; urgency=low

  * Backport a patch from Unison 2.40.102 to fix compatibility with
    OCaml >= 4

 -- Stéphane Glondu <glondu@debian.org>  Sat, 11 May 2013 12:30:14 +0200

unison2.32.52 (2.32.52-6ubuntu1) raring; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Change default logfile directory to .unison by prepending .unison to
      name of logfile in ubase/trace.ml.
  * Dropped changes:
    - debian/rules: use rsvg-convert, rsvg does note exist anymore (done in
      Debian)

 -- Logan Rosen <logatronico@gmail.com>  Sat, 27 Oct 2012 17:48:27 -0400

unison2.32.52 (2.32.52-6) unstable; urgency=low

  * Suggest unison-all
  * Use rsvg-convert instead of rsvg (Closes: #666281)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 31 Mar 2012 19:22:54 +0200

unison2.32.52 (2.32.52-5ubuntu1) precise; urgency=low

  * Merge from debian (LP: #937596):
  * debian/rules: use rsvg-convert, rsvg does note exist anymore
  * Change default logfile directory to .unison by prepending .unison to
    name of logfile in ubase/trace.ml. 

 -- Julian Taylor <jtaylor@ubuntu.com>  Tue, 28 Feb 2012 20:04:01 +0100

unison2.32.52 (2.32.52-5) unstable; urgency=low

  * Remove unison-gtk alternative on uninstall (Closes: #656355)
  * Fix link order to list C objects before the libraries they require
    (Closes: #657423)
  * Add myself to Uploaders, remove Sylvain

 -- Stéphane Glondu <glondu@debian.org>  Fri, 27 Jan 2012 07:31:13 +0100

unison2.32.52 (2.32.52-4) unstable; urgency=low

  * Team upload
  * Fork a unison2.32.52 package, to maintain compatibility with squeeze
  * debian/control:
    - replace Conflicts by Replaces/Breaks
    - bump Standards-Version to 3.9.2 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 08 Jan 2012 13:03:50 +0100

unison (2.32.52-3) unstable; urgency=low

  * Team upload
  * Remove obsolete README.source
  * Add Fix-bad-interaction-with-OpenSSH-5.6.patch (Closes: #620031)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 03 Apr 2011 13:16:18 +0200

unison (2.32.52-2) unstable; urgency=low

  * Team upload
  * Switch source package format to 3.0 (quilt)
  * Add patch to fix build with OCaml 3.12 (Closes: #585453)
  * Add "set -e" to maintainer scripts
  * Remove conflicts older than oldstable
  * Bump Standards-Version to 3.9.1

 -- Stéphane Glondu <glondu@debian.org>  Thu, 10 Feb 2011 12:21:24 +0100

unison (2.32.52-1) unstable; urgency=low

  * New upstream release (Closes: #559054)
  * Merge changes from unison2.27.57:
    * Move ${F:OtherUnison*} fields first due to a problem when merging
      conflicts in dpkg-gencontrol
  * Generate manpage using debian/generate-manpage.ml and output of 'unison
    -help', so manpage is always up-to-date
    (Closes: #524526, #517972, #524475)
  * Backup files changed during build (lwt/depend, ubase/depend)

 -- Sylvain Le Gall <gildor@debian.org>  Sat, 27 Feb 2010 18:57:02 +0000

unison (2.27.57-4) unstable; urgency=low

  * Merge changes from unison2.27.57:
    * Update Standards-Version to 3.8.4 (no change)
    * Stop using dh_desktop
    * Use dh_ocaml 0.9 features (auto dependencies)
  * unison binaries are custom executables, so we can remove Depends on any
    ocaml-base* packages (Closes: #540481)
  * Add bash_completion (Closes: #349782, #481070)
  * Use the full path to access icon in .desktop (Closes: #541700)
  * Patch from unison trunk to remove 'Connected ...' message even when
    -silent is set (Closes: #497729, #551199)
  * Auto generate conflicts with unisonX.Y.Z or unison (X.Y.Z) package
    (Closes: #570910)
  * Enhance templating for unison and unison-gtk common files

 -- Sylvain Le Gall <gildor@debian.org>  Thu, 25 Feb 2010 01:00:47 +0000

unison (2.27.57-2) unstable; urgency=low

  * Correct typo in documentation, thanks to Lucas B. Cohen
    (Closes: #137960, #129478, #466173)
  * Switch packaging to git
  * Set maintainer to Debian OCaml Maintainers
  * Add dh-ocaml build-dependency (rules/ocaml.mk)
  * Upgrade debian/compat to 7
  * Upgrade Standards-Version to 3.8.0 (debian/README.source)
  * Add ${misc:Depends} to dependencies
  * Update debian/copyright file to use
    http://wiki.debian.org/Proposals/CopyrightFormat
  * Remove obsolete debian/control.in related variables and files

 -- Sylvain Le Gall <gildor@debian.org>  Thu, 05 Mar 2009 12:10:11 +0100

unison (2.27.57-1) unstable; urgency=low

  [ Sylvain Le Gall]
  * New upstream release (Closes: #462598):
    * New option mountpoint can help avoid problem with removable media
      (Closes: #349674)
  * Unset CFLAGS in debian/rules (Closes: #476051)
  * Upgrade to standards version 3.7.3 (no change)
  * Update README.Debian to add new package unison2.13.16
  * Remove debian/control.in
  * Remove now useless gtkfont patch
  * Change doc-base section to File Management

  [ Stefano Zacchiroli ]
  * promote Homepage to a real debian/control field, now that dpkg supports it
  * fix vcs-svn field to point just above the debian/ dir

 -- Sylvain Le Gall <gildor@debian.org>  Mon, 14 Apr 2008 19:39:39 +0200

unison (2.13.16-9) unstable; urgency=low

  * Use a correct way to test thing in shell (Closes: #443715)

 -- Sylvain Le Gall <gildor@debian.org>  Sun, 23 Sep 2007 23:54:42 +0200

unison (2.13.16-8) unstable; urgency=low

  * Change section from net to utils
  * Tighten build-dependency on lablgtk2 and librsvg2
  * Rework description of the package

 -- Sylvain Le Gall <gildor@debian.org>  Thu, 20 Sep 2007 16:53:23 +0200

unison (2.13.16-7) unstable; urgency=low

  * Upgrade debian/watch version to 3,
  * Upgrade debhelper debian/compat to 5,


=== debian/control ===
Source: unison2.32.52
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends: cdbs (>= 0.4.23),
 debhelper (>= 7),
 ocaml-nox (>= 3.10.0-8),
 liblablgtk2-ocaml-dev (>= 2.12.0-2),
 chrpath,
 librsvg2-bin (>= 2.18.2),
 imagemagick,
 dh-ocaml (>= 0.9.1)
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/unison.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/unison.git
Homepage: http://www.cis.upenn.edu/~bcpierce/unison/

Package: unison2.32.52
Architecture: any
Depends: ${shlibs:Depends}, ${ocaml:Depends}, ${misc:Depends}
Recommends: ssh-client | openssh-client
Suggests: unison-all
Replaces: ${F:OtherUnison}
Breaks: ${F:OtherUnison}
Description: file-synchronization tool for Unix and Windows
 Unison is a file-synchronization tool for Unix and Windows, written
 in OCaml. It allows two replicas of a collection of files and
 directories to be stored on different hosts (or different disks
 on the same host), modified separately, and then brought up to
 date by propagating the changes in each replica to the other.
 .
 Unison offers several advantages over various synchronization methods
 such as CVS, Coda, rsync, Intellisync, etc. Unison can run on and
 synchronize between Windows and many UNIX platforms. Unison requires
 no root privileges, system access or kernel changes to function. Unison
 can synchronize changes to files and directories in both directions,
 on the same machine, or across a network using ssh or a direct
 socket connection.
 .
 Transfers are optimised using a version of the rsync protocol,
 making it ideal for slower links. Unison has a clear and precise
 specification, and is resilient to failure due to its careful
 handling of the replicas and its private structures.

Package: unison2.32.52-gtk
Architecture: any
Depends: ${shlibs:Depends}, ${ocaml:Depends}, ${misc:Depends}
Replaces: ${F:OtherUnisonGtk}
Breaks: ${F:OtherUnisonGtk}
Recommends: ssh-askpass, ssh-client | openssh-client
Suggests: unison-all-gtk
Description: file-synchronization tool for Unix and Windows with GTK+ interface
 Unison is a file-synchronization tool for Unix and Windows, written
 in OCaml. It allows two replicas of a collection of files and
 directories to be stored on different hosts (or different disks
 on the same host), modified separately, and then brought up to
 date by propagating the changes in each replica to the other.
 .
 Unison offers several advantages over various synchronization methods
 such as CVS, Coda, rsync, Intellisync, etc. Unison can run on and
 synchronize between Windows and many UNIX platforms. Unison requires
 no root privileges, system access or kernel changes to function. Unison
 can synchronize changes to files and directories in both directions,
 on the same machine, or across a network using ssh or a direct
 socket connection.
 .
 Transfers are optimised using a version of the rsync protocol,
 making it ideal for slower links. Unison has a clear and precise
 specification, and is resilient to failure due to its careful
 handling of the replicas and its private structures.
 .
 This package adds the optional GTK+ interface.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for unison package
# Copyright (C) 2006-2009 Sylvain Le Gall <gildor@debian.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
# MA 02110-1301, USA.

include /usr/share/cdbs/1/rules/ocaml.mk
include /usr/share/cdbs/1/rules/debhelper.mk

VERSION=$(DEB_UPSTREAM_VERSION)
# version used with addversionno in unison
VERSIONNO=$(shell echo $(VERSION) | cut -f 1-2 -d .)

ifeq ($(DEB_SOURCE_PACKAGE),unison)
# latest package
PACKAGE_VERSION=
PRIORITY=20
# unison-gtk can replaced unison
PRIORITY_GTK=15
else
# compatibility package
PACKAGE_VERSION=$(VERSION)
PRIORITY=10
PRIORITY_GTK=5
endif

TR=$(subst .,_,$(subst -,_,$1))

UNISON=unison-$(VERSION)
UNISON_MAJ=UNISON-$(VERSION)
UNISON_PACKAGE=unison$(PACKAGE_VERSION)
UNISON_ALTERNATIVE=$(if $(PACKAGE_VERSION),$(UNISON),unison-latest-stable)
UNISON_VERSIONNO=unison-$(VERSIONNO)
UNISON_VAR=$(call TR,$(UNISON))

UNISON_GTK=unison-$(VERSION)-gtk
UNISON_GTK_PACKAGE=$(UNISON_PACKAGE)-gtk
UNISON_GTK_ALTERNATIVE=$(if $(PACKAGE_VERSION),$(UNISON_GTK),unison-latest-stable-gtk)
UNISON_GTK_VERSIONNO=unison-$(VERSIONNO)-gtk
UNISON_GTK_VAR=$(call TR,$(UNISON_GTK))

RENAME := debian/unison.1.in
RENAME += debian/unison.doc-base.in
RENAME += debian/unison-gtk.menu.in
RENAME += debian/unison-gtk.svg.in
RENAME += debian/unison-gtk.install.in
RENAME += debian/unison.install.in
RENAME += debian/unison-gtk.desktop.in

ifeq ($(DEB_SOURCE_PACKAGE),unison)
OTHER_UNISON_PACKAGE=unison$(VERSION)
OTHER_UNISON_GTK_PACKAGE=unison$(VERSION)-gtk
else
OTHER_UNISON_PACKAGE=unison (<< $(VERSION)-999)
OTHER_UNISON_GTK_PACKAGE=unison-gtk (<< $(VERSION)-999)
endif
DEB_DH_GENCONTROL_ARGS += -- "-VF:OtherUnisonGtk=$(OTHER_UNISON_GTK_PACKAGE)" "-VF:OtherUnison=$(OTHER_UNISON_PACKAGE)"


MY_MAKE_FLAGS += $(shell if test -x /usr/bin/ocamlopt.opt; then echo "OCAMLOPT=ocamlopt.opt"; fi )

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
  NATIVE := true
else
  NATIVE := false
  DEB_STRIP_EXCLUDE := $(UNISON) $(UNISON_GTK)
endif

UISTYLE := $(shell dpkg --compare-versions 2.10 ge $(VERSION) && echo gtk || echo gtk2)

DEB_INSTALL_DOCS_ALL := BUGS.txt TODO.txt unison-manual.txt -X unison.doc-base.in

DEB_INSTALL_CHANGELOGS_ALL := NEWS

#
# Build unison
#

configure::
	cp config/Makefile.unix config/Makefile

build/$(UNISON_PACKAGE)::
	$(MAKE) UISTYLE=text NATIVE=$(NATIVE) $(MY_MAKE_FLAGS) CFLAGS=
	mv '$(CURDIR)/unison' '$(CURDIR)/$(UNISON)'

build/$(UNISON_GTK_PACKAGE):: debian/$(UNISON_GTK_PACKAGE).xpm
	$(MAKE) UISTYLE=$(UISTYLE) NATIVE=$(NATIVE) $(MY_MAKE_FLAGS) CFLAGS=
	mv '$(CURDIR)/unison' '$(CURDIR)/$(UNISON_GTK)'
	if test 'x$(OCAML_HAVE_OCAMLOPT)' = 'xyes'; then /usr/bin/chrpath -d '$(CURDIR)/$(UNISON_GTK)'; fi

clean::
	-$(RM) '$(CURDIR)/$(UNISON_GTK)'
	-$(RM) '$(CURDIR)/$(UNISON)'
	$(MAKE) clean
	rm lwt/depend ubase/depend

debian/unison-manual.txt: build/$(UNISON_PACKAGE)
	env HOME='$(CURDIR)' '$(CURDIR)/$(UNISON)' -doc all > '$(CURDIR)/unison-manual.txt'

debian/unison.1.in: build/$(UNISON_PACKAGE)
	cp debian/unison-intro.1.in debian/unison.1.in
	env HOME='$(CURDIR)' ocaml debian/generate-manpage.ml '$(CURDIR)/$(UNISON)' >> debian/unison.1.in
	cat debian/unison-outro.1.in >> debian/unison.1.in

clean::
	-$(RM) unison-manual.txt
	-$(RM) debian/unison.1.in

common-binary-arch:: debian/unison-manual.txt debian/unison.1.in

#
# Unison icons
#

debian/$(UNISON_GTK_PACKAGE).png: debian/unison-gtk.svg.in
	 rsvg-convert -f png -w 32 -h 32 -o $@ $^

debian/$(UNISON_GTK_PACKAGE).xpm: debian/$(UNISON_GTK_PACKAGE).png
	convert $^ $@

clean::
	-$(RM) '$(CURDIR)/debian/$(UNISON_GTK_PACKAGE).png'
	-$(RM) '$(CURDIR)/debian/$(UNISON_GTK_PACKAGE).xpm'

#
# Generate debhelper files using templates
#

SED_REPLACE += -e "s/@VERSION@/$(VERSION)/g"
SED_REPLACE += -e "s/@PACKAGE_VERSION@/$(PACKAGE_VERSION)/g"

SED_REPLACE += -e "s/@PRIORITY@/$(PRIORITY)/g"
SED_REPLACE += -e "s/@UNISON@/$(UNISON)/g"
SED_REPLACE += -e "s/@UNISON_PACKAGE@/$(UNISON_PACKAGE)/g"
SED_REPLACE += -e "s/@UNISON_ALTERNATIVE@/$(UNISON_ALTERNATIVE)/g"
SED_REPLACE += -e "s/@UNISON_VERSIONNO@/$(UNISON_VERSIONNO)/g"
SED_REPLACE += -e "s/@UNISON_VAR@/$(UNISON_VAR)/g"
SED_REPLACE += -e "s/@UNISON_MAJ@/$(UNISON_MAJ)/g"

SED_REPLACE += -e "s/@PRIORITY_GTK@/$(PRIORITY_GTK)/g"
SED_REPLACE += -e "s/@UNISON_GTK@/$(UNISON_GTK)/g"
SED_REPLACE += -e "s/@UNISON_GTK_PACKAGE@/$(UNISON_GTK_PACKAGE)/g"
SED_REPLACE += -e "s/@UNISON_GTK_ALTERNATIVE@/$(UNISON_GTK_ALTERNATIVE)/g"
SED_REPLACE += -e "s/@UNISON_GTK_VERSIONNO@/$(UNISON_GTK_VERSIONNO)/g"
SED_REPLACE += -e "s/@UNISON_GTK_VAR@/$(UNISON_GTK_VAR)/g"

SED_REPLACE += -e "s/@PRIORITY_SELF@/$(PRIORITY_SELF)/g"
SED_REPLACE += -e "s/@UNISON_SELF@/$(UNISON_SELF)/g"
SED_REPLACE += -e "s/@UNISON_SELF_PACKAGE@/$(UNISON_SELF_PACKAGE)/g"
SED_REPLACE += -e "s/@UNISON_SELF_ALTERNATIVE@/$(UNISON_SELF_ALTERNATIVE)/g"
SED_REPLACE += -e "s/@UNISON_SELF_VERSIONNO@/$(UNISON_SELF_VERSIONNO)/g"
SED_REPLACE += -e "s/@UNISON_SELF_VAR@/$(UNISON_SELF_VAR)/g"
SED_REPLACE += -e "s/@IS_GTK@/$(IS_GTK)/g"

%-template-stamp: $(wildcard debian/templates/*)
	for i in $^ ; do   \
	   sed $(SED_REPLACE) $$i > debian/$(UNISON_SELF_PACKAGE).$$(basename $$i); \
	done;
	touch $@

clean::
	for i in $(wildcard debian/templates/*); do \
	   $(RM) -f debian/$(UNISON_GTK_PACKAGE).$$(basename $$i); \
	   $(RM) -f debian/$(UNISON_PACKAGE).$$(basename $$i); \
	done
	-$(RM) unison-gtk-template-stamp unison-template-stamp

unison-gtk-template-stamp: PRIORITY_SELF = $(PRIORITY_GTK)
unison-gtk-template-stamp: UNISON_SELF = $(UNISON_GTK)
unison-gtk-template-stamp: UNISON_SELF_PACKAGE = $(UNISON_GTK_PACKAGE)
unison-gtk-template-stamp: UNISON_SELF_ALTERNATIVE = $(UNISON_GTK_ALTERNATIVE)
unison-gtk-template-stamp: UNISON_SELF_VERSIONNO = $(UNISON_GTK_VERSIONNO)
unison-gtk-template-stamp: UNISON_SELF_VAR = $(UNISON_GTK_VAR)
unison-gtk-template-stamp: IS_GTK=true

unison-template-stamp: PRIORITY_SELF = $(PRIORITY)
unison-template-stamp: UNISON_SELF = $(UNISON)
unison-template-stamp: UNISON_SELF_PACKAGE = $(UNISON_PACKAGE)
unison-template-stamp: UNISON_SELF_ALTERNATIVE = $(UNISON_ALTERNATIVE)
unison-template-stamp: UNISON_SELF_VERSIONNO = $(UNISON_VERSIONNO)
unison-template-stamp: UNISON_SELF_VAR = $(UNISON_VAR)
unison-template-stamp: IS_GTK=false

template: unison-template-stamp unison-gtk-template-stamp

.PHONY: template

common-binary-indep:: template
common-binary-arch:: template

#
# Rename and substitute files
#

unison-rename: unison-rename-stamp
unison-rename-stamp: $(RENAME)
	# Rename all the debhelper files needed and substitue the @XXX@
	# string
	for i in $^ ; do \
	  DST=`echo $$i | sed -e "s/unison/${UNISON_PACKAGE}/" -e "s/\\.in\\$$//"`; \
	  sed $(SED_REPLACE) $$i > "$(CURDIR)/$$DST"; \
	done
	
	# We always need to rename the manual
	cp '$(CURDIR)/debian/$(UNISON_PACKAGE).1' '$(CURDIR)/debian/$(UNISON).1'
	# We copy unison.1 to unison-gtk.1
	cp '$(CURDIR)/debian/$(UNISON).1' '$(CURDIR)/debian/$(UNISON_GTK).1'
	
	touch $@

clean::
	# Remove the renamed files
	-for i in $(RENAME); do \
	  DST=`echo $$i | sed -e "s/unison/${UNISON_PACKAGE}/" -e "s/\\.in\\$$//"`; \
	  $(RM) "$(CURDIR)/$$DST"; \
	done
	-$(RM) '$(CURDIR)/debian/$(UNISON).1'
	-$(RM) '$(CURDIR)/debian/$(UNISON_GTK).1'
	-$(RM) '$(CURDIR)/unison-rename-stamp'

.PHONY: unison-rename

common-binary-indep:: unison-rename template
common-binary-arch:: unison-rename template

=== debian/watch ===
version=3
http://www.cis.upenn.edu/~bcpierce/unison/download/releases/stable/unison-(2.32.[0-9\.]*)\.tar\.gz
